<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        // Khởi tạo các đánh dấu thứ tụ cho các cel khi đổ data vào table
        const gEND_OF_ROW_COL = -1;
        const gORDER_CODE = 0;
        const gCOMBO_SIZE = 1;
        const gPIZZA_TYPE = 2;
        const gDRINK = 3;
        const gPRICE = 4;
        const gFULLNAME = 5;
        const gPHONE = 6;
        const gSTATUS = 7;
        const gACTION = 8;
        // Khởi tạo biến lưu trên file orderDetail.html để truyền query string sang
        var gORDER_DETAIL_PAGE = "./31.20b.html";

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        // Hàm thêm sự kiện onclick cho nút "Chi tiết"
        function onBtnDetailClick(paramOrderButton) {
            // Lấy ra giá trị Id và orderCode thông qua thuộc tính data-* được lưu trên button "Chi tiết"
            var vOrderId = paramOrderButton.getAttribute("data-order-id");
            var vOrderCode = paramOrderButton.getAttribute("data-order-code");
            console.log(`%cThông tin Order khi nhấn nút button Chi Tiết với OrderCode: ${vOrderCode}`, `color:blue`);
            console.log("Order ID: " + vOrderId);
            console.log("Order Code: " + vOrderCode);

            // Gọi và truyền data qua form orderDetail.html
            var vUrlSiteToOpen = gORDER_DETAIL_PAGE + "?id=" + vOrderId + "&orderCode=" + vOrderCode;
            window.location.href = vUrlSiteToOpen;
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log("%cThông tin Order:", "color:orange");
                    console.log(vXmlHttpGetAllOrders.responseText);
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            // Convert JSON String sang Object Order
            var vOrderObject = JSON.parse(paramXMLHttpAllOrder.responseText);

            // Truy xuất đến thẻ table và tbody để load dữ liệu
            var vTable = document.getElementById("table-order");
            var vTBody = document.getElementsByTagName("tbody")[0];

            // Dùng vòng lặp for để tạo mỗi dòng cho table
            for(var bIndex = 0; bIndex < vOrderObject.length; bIndex ++) {
                var vOrder = vOrderObject[bIndex];
                // Tạo dòng mới cho bảng và ghi vào các giá trị
                var vRow = vTBody.insertRow(gEND_OF_ROW_COL);
                // Thêm từng ô trên mỗi dòng
                var vCellOrderCode = vRow.insertCell(gORDER_CODE);
                var vCellComboSize = vRow.insertCell(gCOMBO_SIZE);
                var vCellPizzaType = vRow.insertCell(gPIZZA_TYPE);
                var vCellDrink = vRow.insertCell(gDRINK);
                var vCellPrice = vRow.insertCell(gPRICE);
                var vCellFullname = vRow.insertCell(gFULLNAME);
                var vCellPhone = vRow.insertCell(gPHONE);
                var vCellStatus = vRow.insertCell(gSTATUS);
                var vCellAction = vRow.insertCell(gACTION);

                // Gán giá trị của từng thuộc tính vào mỗi cell ở hàng hiện tại
                vCellOrderCode.innerHTML = vOrder.orderCode;
                vCellComboSize.innerHTML = vOrder.kichCo;
                vCellPizzaType.innerHTML = vOrder.loaiPizza;
                vCellDrink.innerHTML = vOrder.idLoaiNuocUong;
                vCellPrice.innerHTML = vOrder.thanhTien;
                vCellFullname.innerHTML = vOrder.hoTen;
                vCellPhone.innerHTML = vOrder.soDienThoai;
                vCellStatus.innerHTML = vOrder.trangThai;

                // Lưu dữ liệu Đơn Hàng thông qua thuộc tính dataset vào button 'Chi Tiết'
                var vButton = document.createElement("button");
                vButton.innerHTML = "Chi tiết";
                vButton.className = "btn btn-info";
                vButton.setAttribute("onclick", "onBtnDetailClick(this)");
                vButton.setAttribute("data-order-id", vOrder.id);
                vButton.setAttribute("data-order-code", vOrder.orderCode);
                vCellAction.appendChild(vButton);
            }
        }

    </script>
</body>

</html>